using System;
using System.Runtime.InteropServices;

using NETVSL_Types;
using NETVSL_Common;
using Visio = Microsoft.Office.Interop.Visio;

namespace NVTest_ColorInc
{

  [ClassInterface(ClassInterfaceType.None)]    
  public class NETVSL: INETVSL {

    public NETVSL() {

    }

    //----------------------------------------
    public NETVSL_ResultCodes Load (Int32 InterfaceVersion) {

      return NETVSL_ResultCodes.SUCCESS;      
    }

    //----------------------------------------
    public int AddonCount {
      get {
        return 1;
      }
    }

    //----------------------------------------
    public NETVSL_ResultCodes GetAddonInfo ( 
      Int32 SessionId , 
      Int32 AddOnIx , 
      ref String Name , 
      ref NETVSL_AddOnInfo_Attribs Attribs , 
      ref NETVSL_AddOnInfo_EnableMask EnableMask , 
      ref NETVSL_AddOnInfo_InvokeOnMask InvokeOnMask , 
      ref NETVSL_AddOnInfo_NotifyOnMask NotifyOnMask ) {

      Name = "NVTest_ColorInc_Addon"; // Tidy to make this an embellishment of namespace name

      Attribs      = NETVSL_AddOnInfo_Attribs.ATTS_ISACTION ;
      EnableMask   = NETVSL_AddOnInfo_EnableMask.ENABLEALWAYS ;
      InvokeOnMask = NETVSL_AddOnInfo_InvokeOnMask.INVOKE_DEFAULT ;
      NotifyOnMask = NETVSL_AddOnInfo_NotifyOnMask.NOTIFY_DEFAULT;

      return NETVSL_ResultCodes.SUCCESS; 
    }

    //----------------------------------------
    public NETVSL_ResultCodes IsAddOnEnabled (System.Int32 AddOnIx , System.Int32 SessionId ) {

      return NETVSL_ResultCodes.L2V_ENABLED;      
    }
  
    //----------------------------------------
    public Int32 PollNextEndSessionMessage (ref Int32 SessionId ) {

      return -1; // -1 to indicate ignore and no more
    }

    //----------------------------------------
    public Int32 PollNextTraceMessage (ref NETVSL_AdapterMessage MsgType, ref String Text ) {
      return -1; // -1 to indicate ignore and no more
    }

    //----------------------------------------
    public void KillSession ( System.Int32 SessionId ) {

    }

    //----------------------------------------
    public NETVSL_ResultCodes Run (Int32 AddOnIx , Int32 SessionId , String Args ) {

      TArgHandler ArgHandler = new TArgHandler();
      String ArgStrForShape = "";
      
      //----------------------------------------
      // Parse Args, prep to write to Shape.Text
      //----------------------------------------
      
      ArgHandler.ParseArgs(Args);      
      
      for (int Ix0 = 0; Ix0 < ArgHandler.ArgCount(); Ix0++) {
        ArgStrForShape = ArgStrForShape 
                       + ArgHandler.Keys(Ix0) + " = " 
                       + ArgHandler.Values(Ix0) 
                       + "\n";      
      }
      
      //-------------------------------------------
      // Extremely Lazy Hack
      //-------------------------------------------
      Visio.Application VisApp  = null;
      Visio.Page        APage   = null;
      Visio.Shape       AShape  = null;
      Visio.Cell        ACell   = null;
      try {
        VisApp = (Visio.Application) Marshal.GetActiveObject("visio.application");
      } catch {
//        MessageBox.Show("Visio does not seem to be running");
      }  

      if (VisApp == null) goto done;
    
      APage = VisApp.ActivePage;
      AShape = APage.Shapes[1];

      if (AShape == null) goto done;
      
      AShape.Text = ArgStrForShape;

      ACell = AShape.get_Cells("FillForegnd");
      
      if (ACell == null) goto done;

      Int32 ColorInt = ACell.get_ResultInt(0, 0);

      ColorInt = ColorInt + 1;
      if (ColorInt > 15) ColorInt = 0;

      ACell.Formula  = ColorInt.ToString();

      done: ;

      return NETVSL_ResultCodes.SUCCESS;      
    }

    //----------------------------------------
    public NETVSL_ResultCodes Unload (  ) {
      return NETVSL_ResultCodes.SUCCESS;      
    }

    //----------------------------------------
    public Int32 Test ( Int32 I ) {
      return I + 7;
    }

    //----------------------------------------
    public void VSLInfo (ref String Descr ) {
      Descr = "Version 1002"; 
    }
  }

}
