/*-------------------------------------
If using the NETVSL_Base scheme, this module is the one
that instantiates a NETVSL class, exposing an INETVSL
interface to the world (and to COM, which is what we care about).

As you can see, the main solution-specific features are:

-- Set some names appropriately:
  namespace.classname gives us the name by which the Adapter
  will find and instantiate this object. In this case:
  NVTest_TwoAddons.NETVSL
  
-- Be sure to set the  ClassInterface(ClassInterfaceType.None)
  attribute on the class, as this is what prohibits .NET from
  adding a bunch of reflection interface members that are not
  expected by COM
  
-- And the actual work... instantiate the Addons and add them
  to the list of Addons managed by this class.
  
-- And of course, there's some other work done by the inherited
  TNETVSL_Base class, but in general no need to override that.  

--------------------------------------*/


using System;
using System.Runtime.InteropServices;

using NETVSL_Base;

//---------------------------
namespace NVTest_TwoAddons
//---------------------------
{

  //---------------------------
  [ClassInterface(ClassInterfaceType.None)] 
	public class NETVSL: TNETVSL_Base
  //---------------------------
	{
		public NETVSL()
		{
		  //---------------------------------------------------
		  // Automatically calls base constructor first, then...
		  // we add our Addons
		  //---------------------------------------------------
		  
		  Addon_Add(new TNVTest_TwoAddons_Addon01(this) );      
		  Addon_Add(new TNVTest_TwoAddons_Addon02(this) );      
		}
	}
}
